bank_app/urls.py
from django.urls import path
from . import views
from django.views.generic import RedirectView

app_name = 'bank_app'

urlpatterns = [
    path('', views.index, name='index'),
    path('customer/', views.customerPortal, name='customer_portal'),
    path('<int:pk>/', views.accountDetails, name='account_details'),
    path('movement/<int:pk>/', views.movementDetails, name='movement_details'),
    path('create_account/', views.createAccount, name='create_account'),
    path('staff_customer_view/<int:pk>/', views.staffCustomerView, name='staff_customer_view'),
    path('create_customer/', views.createCustomer, name='create_customer'),
    # redirect to customer view when two-factor is complete
    path('account/two_factor/setup/complete/', RedirectView.as_view(url='/customer/')),
    path('make_transfer/', views.make_transfer, name='make_transfer'),
    path('internal_transfer', views.internal_transfer, name='internal_transfer'),
    path('bank_to_bank_transfer', views.bank_to_bank_transfer, name='bank_to_bank_transfer'),
    path('transaction_details/<int:transactionId>/', views.make_transfer, name='transaction_details'),
    path('staff_portal/', views.staffPortal, name='staff_portal'),
    path('staff_search/', views.staffSearch, name='staff_search'),
    path('take_loan/', views.take_loan, name='take_loan'),
    path('approve_loans/', views.approve_loan, name='staff_approve_loans'),
    path('approve/<int:pk>/', views.approve, name='approve'),
    path('decline/<int:pk>/>', views.decline, name='decline'),
]

bank_project/urls.py
from django.contrib import admin
from django.urls import path, include
from two_factor.urls import urlpatterns as tf_urls
from two_factor.admin import AdminSiteOTPRequired

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('bank_app.urls')),
    path('', include(tf_urls)),
    path('accounts/', include('django.contrib.auth.urls'))
]

templates/base.html
<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8" />
        <meta name="viewport" content="width=device-width, initial-scale=1.0" />
        <script src="https://unpkg.com/htmx.org@1.9.0" integrity="sha384-aOxz9UdWG0yBiyrTwPeMibmaoq07/d3a96GCbb9x60f3mOt5zwkjdbcHFnKH8qls" crossorigin="anonymous"></script>
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/water.css@2/out/water.css">
        <title>Omega Bank</title>
    </head>

    <body>
        <header>
            {% if user.is_staff %}
            <h2>Omega Bank – Staff Portal</h2>
            {% else %}
            <h2>Omega Bank – Customer Portal</h2>
            {% endif %}
        </header>
        <nav>
            {% if user.is_staff %}
            <a href="{% url 'bank_app:staff_approve_loans' %}">Approve Loans</a>
            {% else %}
            <a href="{% url 'bank_app:make_transfer' %}">Transfer</a>
            <a href="{% url 'bank_app:take_loan' %}">Apply for loan</a>
            {% endif %}
            <a href="{% url 'logout' %}">Log Out</a>
        </nav>
        <main>
            {% block main %}
            {% endblock main %}
        </main>
        <footer>
            <table>
                <tr>
                    <td><h6>Omega Bank Global</h6></td>
                    <td><h6>Copenhagen, Denmark</h6></td>
                    <td><h6>Copyright 2023</h6></td>
                </tr>
            </table>
        </footer>
        <script src="https://unpkg.com/htmx.org@1.5.0" integrity="sha384-oGA+prIp5Vchu6we2YkI51UtVzN9Jpx2Z7PnR1I78PnZlN8LkrCT4lqqqmDkyrvI" crossorigin="anonymous"></script>

        <script>
            document.body.addEventListener('htmx:configRequest', (event) => {
                event.detail.headers['X-CSRFToken'] = '{{ csrf_token }}';
            })
        </script>
    </body>
</html>